<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPresalesRankWeightUpdater ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPresalesRankWeightUpdater
 * @subpackage Arrays
 */
class ArrayOfPresalesRankWeightUpdater extends AbstractStructArrayBase
{
    /**
     * The PresalesRankWeightUpdater
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\PresalesRankWeightUpdater[]
     */
    public $PresalesRankWeightUpdater;
    /**
     * Constructor method for ArrayOfPresalesRankWeightUpdater
     * @uses ArrayOfPresalesRankWeightUpdater::setPresalesRankWeightUpdater()
     * @param \patest\StructType\PresalesRankWeightUpdater[] $presalesRankWeightUpdater
     */
    public function __construct(array $presalesRankWeightUpdater = array())
    {
        $this
            ->setPresalesRankWeightUpdater($presalesRankWeightUpdater);
    }
    /**
     * Get PresalesRankWeightUpdater value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\PresalesRankWeightUpdater[]|null
     */
    public function getPresalesRankWeightUpdater()
    {
        return isset($this->PresalesRankWeightUpdater) ? $this->PresalesRankWeightUpdater : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPresalesRankWeightUpdater method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPresalesRankWeightUpdater method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePresalesRankWeightUpdaterForArrayConstraintsFromSetPresalesRankWeightUpdater(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPresalesRankWeightUpdaterPresalesRankWeightUpdaterItem) {
            // validation for constraint: itemType
            if (!$arrayOfPresalesRankWeightUpdaterPresalesRankWeightUpdaterItem instanceof \patest\StructType\PresalesRankWeightUpdater) {
                $invalidValues[] = is_object($arrayOfPresalesRankWeightUpdaterPresalesRankWeightUpdaterItem) ? get_class($arrayOfPresalesRankWeightUpdaterPresalesRankWeightUpdaterItem) : sprintf('%s(%s)', gettype($arrayOfPresalesRankWeightUpdaterPresalesRankWeightUpdaterItem), var_export($arrayOfPresalesRankWeightUpdaterPresalesRankWeightUpdaterItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PresalesRankWeightUpdater property can only contain items of type \patest\StructType\PresalesRankWeightUpdater, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PresalesRankWeightUpdater value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\PresalesRankWeightUpdater[] $presalesRankWeightUpdater
     * @return \patest\ArrayType\ArrayOfPresalesRankWeightUpdater
     */
    public function setPresalesRankWeightUpdater(array $presalesRankWeightUpdater = array())
    {
        // validation for constraint: array
        if ('' !== ($presalesRankWeightUpdaterArrayErrorMessage = self::validatePresalesRankWeightUpdaterForArrayConstraintsFromSetPresalesRankWeightUpdater($presalesRankWeightUpdater))) {
            throw new \InvalidArgumentException($presalesRankWeightUpdaterArrayErrorMessage, __LINE__);
        }
        if (is_null($presalesRankWeightUpdater) || (is_array($presalesRankWeightUpdater) && empty($presalesRankWeightUpdater))) {
            unset($this->PresalesRankWeightUpdater);
        } else {
            $this->PresalesRankWeightUpdater = $presalesRankWeightUpdater;
        }
        return $this;
    }
    /**
     * Add item to PresalesRankWeightUpdater value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\PresalesRankWeightUpdater $item
     * @return \patest\ArrayType\ArrayOfPresalesRankWeightUpdater
     */
    public function addToPresalesRankWeightUpdater(\patest\StructType\PresalesRankWeightUpdater $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\PresalesRankWeightUpdater) {
            throw new \InvalidArgumentException(sprintf('The PresalesRankWeightUpdater property can only contain items of type \patest\StructType\PresalesRankWeightUpdater, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PresalesRankWeightUpdater[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\PresalesRankWeightUpdater|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\PresalesRankWeightUpdater|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\PresalesRankWeightUpdater|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\PresalesRankWeightUpdater|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\PresalesRankWeightUpdater|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PresalesRankWeightUpdater
     */
    public function getAttributeName()
    {
        return 'PresalesRankWeightUpdater';
    }
}
